function banner(context, namespace) {
	return context && namespace ? `(function(exports){`: ''
}
function footer(context, namespace) {
	return context && namespace ? `exports.${namespace} = ${namespace}
}(${context}||(${context}={})))` : ''
}
function iifeNamespace(options) {
	const defaultOptions = {
		context: 'window',
	}
	options = Object.assign({}, defaultOptions, options);
	if (typeof options.context !== 'string') throw new Error('[Error] context property needs to be a string')

	return {
		options(inputOptions) {
			const output = inputOptions.output;
			if (Array.isArray(output)) {
				inputOptions.output = output.map((o) => {
					if (o.format === 'iife' && o.name) {
						o.banner = banner(options.context,o.name) + '\n' + (o.banner || '');
						o.footer = (o.footer || '\n') + footer(options.context,o.name);
					}
				})
			}
			return inputOptions
		}
	}
}

module.exports = iifeNamespace